diff --git a/test/unit/commands/setup/orchestrator_test.rb b/test/unit/commands/setup/orchestrator_test.rb
new file mode 100644
index 00000000..a7157ba9
--- /dev/null
+++ b/test/unit/commands/setup/orchestrator_test.rb
@@ -0,0 +1,373 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/commands/setup"
+require "hive/setup/diagnostics"
+require "stringio"
+
+class SetupOrchestratorTest < Minitest::Test
+  include HiveTestHelper
+
+  def healthy_diag
+    results = %w[
+      ruby git tmux gh claude codex node npm qmd web_bundle sqlite
+    ].map do |name|
+      Hive::Setup::Diagnostics::Result.new(
+        name: name, status: "ok", detail: "#{name} ok", fix: nil, bootstrappable: false
+      )
+    end
+    Hive::Setup::Diagnostics::Report.new(results: results, platform: "linux", ok: true)
+  end
+
+  def bootstrappable_diag
+    results = healthy_diag.results.map do |r|
+      if r.name == "qmd" || r.name == "web_bundle"
+        Hive::Setup::Diagnostics::Result.new(
+          name: r.name, status: "bootstrappable", detail: "need install",
+          fix: "install", bootstrappable: true
+        )
+      else
+        r
+      end
+    end
+    Hive::Setup::Diagnostics::Report.new(results: results, platform: "linux", ok: true)
+  end
+
+  def unauth_diag
+    results = healthy_diag.results.map do |r|
+      if %w[gh claude codex].include?(r.name)
+        Hive::Setup::Diagnostics::Result.new(
+          name: r.name, status: "unauthenticated", detail: "need login",
+          fix: "#{r.name} login", bootstrappable: false
+        )
+      else
+        r
+      end
+    end
+    Hive::Setup::Diagnostics::Report.new(results: results, platform: "linux", ok: false)
+  end
+
+  FakeInstaller = Struct.new(:target, :kind, :messages, keyword_init: true) do
+    def install!(autostart:, force: false)
+      Hive::Commands::ServiceInstaller::Outcome.new(kind)
+    end
+
+    def target_path = target
+    def messages = self[:messages] || []
+    def status_snapshot = { "service_active" => false }
+    def restart! = :ok
+  end
+
+  def build(dir, **opts)
+    out = StringIO.new
+    err = StringIO.new
+    diag = opts.delete(:diag) || healthy_diag
+    qmd_calls = []
+    web_calls = []
+    daemon_calls = []
+    web_svc_calls = []
+    init_calls = []
+    enroll_calls = []
+
+    cmd = Hive::Commands::Setup.new(
+      project_path: opts.delete(:project_path) || dir,
+      service: opts.fetch(:service, false),
+      no_bootstrap: opts.fetch(:no_bootstrap, false),
+      no_init: opts.fetch(:no_init, false),
+      json: opts.fetch(:json, false),
+      binary_path: opts.delete(:binary_path) || "/opt/hive/bin/hive",
+      diagnostics: -> { diag }.then { |p| Object.new.tap { |o| o.define_singleton_method(:call) { diag } } },
+      app_bundle: Object.new.tap { |o|
+        o.define_singleton_method(:ensure_installed!) {
+          web_calls << true
+          File.join(dir, "web-app")
+        }
+      },
+      qmd_installer: -> {
+        qmd_calls << true
+        "qmd installed"
+      },
+      daemon_installer: FakeInstaller.new(target: "/u/hive-daemon.service", kind: :written).tap { |i|
+        i.define_singleton_method(:install!) { |**|
+          daemon_calls << true
+          Hive::Commands::ServiceInstaller::Outcome.new(:written)
+        }
+      },
+      web_installer: FakeInstaller.new(target: "/u/hive-web.service", kind: :written).tap { |i|
+        i.define_singleton_method(:install!) { |**|
+          web_svc_calls << true
+          Hive::Commands::ServiceInstaller::Outcome.new(:written)
+        }
+      },
+      init_runner: ->(path) { init_calls << path; "initialized" },
+      enroll_runner: ->(path) { enroll_calls << path; "enrolled" },
+      output: out,
+      err: err
+    )
+    {
+      cmd: cmd, out: out, err: err,
+      qmd_calls: qmd_calls, web_calls: web_calls,
+      daemon_calls: daemon_calls, web_svc_calls: web_svc_calls,
+      init_calls: init_calls, enroll_calls: enroll_calls
+    }
+  end
+
+  def test_fresh_setup_service_bootstraps_and_reports_url
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true, diag: bootstrappable_diag, json: true)
+      capture_io { ctx[:cmd].call }
+      payload = JSON.parse(ctx[:out].string)
+      assert payload["ok"], payload.inspect
+      assert_equal true, payload["service"]
+      assert_equal "http://127.0.0.1:4567", payload["web_url"]
+      assert_equal [ true ], ctx[:qmd_calls]
+      assert_equal [ true ], ctx[:web_calls]
+      assert_equal [ true ], ctx[:daemon_calls]
+      assert_equal [ true ], ctx[:web_svc_calls]
+      assert_equal [ dir ], ctx[:init_calls]
+      phase_names = payload["phases"].map { |p| p["name"] }
+      assert_includes phase_names, "bootstrap_qmd"
+      assert_includes phase_names, "bootstrap_web_bundle"
+      assert_includes phase_names, "daemon_install"
+      assert_includes phase_names, "web_install"
+    end
+  end
+
+  def test_rerun_on_initialized_repo_uses_enroll_path
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, ".hive-state"))
+      ctx = build(dir, service: false)
+      capture_io { ctx[:cmd].call }
+      assert_empty ctx[:init_calls]
+      assert_equal [ dir ], ctx[:enroll_calls]
+      refute ctx[:web_svc_calls].any?
+    end
+  end
+
+  def test_no_bootstrap_is_diagnose_only
+    with_tmp_dir do |dir|
+      ctx = build(dir, no_bootstrap: true, service: true, diag: bootstrappable_diag, json: true)
+      capture_io { ctx[:cmd].call }
+      payload = JSON.parse(ctx[:out].string)
+      assert payload["ok"]
+      assert_empty ctx[:qmd_calls]
+      assert_empty ctx[:web_calls]
+      assert_empty ctx[:daemon_calls]
+      assert_empty ctx[:web_svc_calls]
+      assert_empty ctx[:init_calls]
+      assert_equal [ "diagnostics" ], payload["phases"].map { |p| p["name"] }
+    end
+  end
+
+  def test_no_init_still_provisions_services
+    with_tmp_dir do |dir|
+      ctx = build(dir, no_init: true, service: true)
+      capture_io { ctx[:cmd].call }
+      assert_equal [ true ], ctx[:daemon_calls]
+      assert_equal [ true ], ctx[:web_svc_calls]
+      assert_empty ctx[:init_calls]
+      assert_empty ctx[:enroll_calls]
+    end
+  end
+
+  def test_missing_auth_blocks_success_and_emits_fix_commands
+    with_tmp_dir do |dir|
+      ctx = build(dir, diag: unauth_diag, json: true, service: true)
+      error = assert_raises(Hive::Error) { ctx[:cmd].call }
+      assert_match(/diagnostics failed/, error.message)
+      payload = JSON.parse(ctx[:out].string)
+      refute payload["ok"]
+      fixes = payload["diagnostics"]["results"].select { |r| r["status"] == "unauthenticated" }.map { |r| r["fix"] }
+      assert_includes fixes, "gh login"
+      assert_includes fixes, "claude login"
+      assert_includes fixes, "codex login"
+      # Still ran provisioning phases for visibility (diag failed but bootstrap continues)
+      assert ctx[:daemon_calls].any? || payload["phases"].any?
+    end
+  end
+
+  def test_phase_failure_keeps_full_json_and_nonzero
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true, json: true)
+      ctx[:cmd].instance_variable_set(:@daemon_installer, Object.new.tap { |o|
+        o.define_singleton_method(:install!) { |**| raise "systemctl down" }
+        o.define_singleton_method(:target_path) { "/u" }
+        o.define_singleton_method(:messages) { [] }
+      })
+      error = assert_raises(Hive::Error) { ctx[:cmd].call }
+      assert_match(/daemon_install|systemctl/, error.message)
+      payload = JSON.parse(ctx[:out].string)
+      refute payload["ok"]
+      daemon_phase = payload["phases"].find { |p| p["name"] == "daemon_install" }
+      refute daemon_phase["ok"]
+      # Later phases still recorded when possible
+      assert payload["phases"].any? { |p| p["name"] == "web_install" } ||
+             payload["phases"].any? { |p| p["name"] == "init" }
+    end
+  end
+
+  def test_init_system_exit_is_recorded_and_later_service_phase_still_runs
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true, json: true)
+      ctx[:cmd].instance_variable_set(:@init_runner, ->(_path) { raise SystemExit.new(64) })
+
+      error = assert_raises(Hive::Error) { ctx[:cmd].call }
+      assert_match(/init.*status 64/, error.message)
+
+      payload = JSON.parse(ctx[:out].string)
+      init_phase = payload["phases"].find { |phase| phase["name"] == "init" }
+      refute init_phase["ok"]
+      assert_match(/status 64/, init_phase["error"])
+      assert_equal [ true ], ctx[:web_svc_calls], "SystemExit must not skip later setup phases"
+    end
+  end
+
+  def test_default_init_uses_non_emitting_programmatic_mode
+    with_tmp_dir do |dir|
+      require "hive/commands/init"
+      options = nil
+      fake = Object.new.tap { |object| object.define_singleton_method(:call) { true } }
+      command = Hive::Commands::Setup.new(project_path: dir)
+
+      replacement = lambda do |_path, **kwargs|
+        options = kwargs
+        fake
+      end
+      with_replaced_singleton_method(Hive::Commands::Init, :new, replacement) do
+        assert_equal "initialized #{dir}", command.send(:default_init, dir)
+      end
+
+      assert_equal false, options.fetch(:emit)
+    end
+  end
+
+  def test_default_enroll_uses_non_emitting_programmatic_mode
+    with_tmp_dir do |dir|
+      require "hive/commands/daemon"
+      options = nil
+      fake = Object.new.tap { |object| object.define_singleton_method(:call) { true } }
+      command = Hive::Commands::Setup.new(project_path: dir)
+      registered = [ { "name" => File.basename(dir), "path" => dir } ]
+
+      replacement = lambda do |_subcommand, _target, **kwargs|
+        options = kwargs
+        fake
+      end
+      with_replaced_singleton_method(Hive::Config, :registered_projects, -> { registered }) do
+        with_replaced_singleton_method(Hive::Commands::Daemon, :new, replacement) do
+          assert_equal "enrolled #{File.basename(dir)}", command.send(:default_enroll, dir)
+        end
+      end
+
+      assert_equal false, options.fetch(:emit)
+    end
+  end
+
+  def test_refreshed_bundle_restarts_active_unchanged_service_and_checks_health
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true, diag: bootstrappable_diag, json: true)
+      restarts = []
+      probes = []
+      installer = FakeInstaller.new(target: "/u/hive-web.service", kind: :unchanged)
+      installer.define_singleton_method(:status_snapshot) { { "service_active" => true } }
+      installer.define_singleton_method(:restart!) { restarts << true; :ok }
+      ctx[:cmd].instance_variable_set(:@web_installer, installer)
+      ctx[:cmd].instance_variable_set(
+        :@web_health_probe,
+        ->(url, timeout:) { probes << [ url, timeout ]; true }
+      )
+
+      ctx[:cmd].call
+      payload = JSON.parse(ctx[:out].string)
+      web_phase = payload["phases"].find { |phase| phase["name"] == "web_install" }
+
+      assert web_phase["ok"], web_phase.inspect
+      assert_equal [ true ], restarts
+      assert_equal 1, probes.length
+      assert_equal "http://127.0.0.1:4567/health", probes.first.first
+      assert_operator probes.first.last, :>, 0
+      assert_match(/restarted=true/, web_phase["detail"])
+    end
+  end
+
+  def test_refreshed_active_service_health_failure_fails_web_phase
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true, diag: bootstrappable_diag, json: true)
+      installer = FakeInstaller.new(target: "/u/hive-web.service", kind: :unchanged)
+      installer.define_singleton_method(:status_snapshot) { { "service_active" => true } }
+      installer.define_singleton_method(:restart!) { :ok }
+      ctx[:cmd].instance_variable_set(:@web_installer, installer)
+      ctx[:cmd].instance_variable_set(:@web_health_probe, ->(_url, timeout:) { false })
+
+      error = assert_raises(Hive::Error) { ctx[:cmd].call }
+      assert_match(/health check failed/, error.message)
+      payload = JSON.parse(ctx[:out].string)
+      web_phase = payload["phases"].find { |phase| phase["name"] == "web_install" }
+      refute web_phase["ok"]
+      assert_match(%r{127\.0\.0\.1:4567/health}, web_phase["error"])
+    end
+  end
+
+  def test_injected_health_probe_is_bounded_by_setup_deadline
+    command = Hive::Commands::Setup.new(
+      web_health_probe: ->(_url, timeout:) { sleep 1; true },
+      web_health_timeout: 0.01
+    )
+    started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+
+    refute command.send(:web_service_healthy?)
+    elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+    assert_operator elapsed, :<, 0.5
+  end
+
+  def test_bare_setup_prints_foreground_hint
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: false)
+      capture_io { ctx[:cmd].call }
+      assert_match(/hive web/, ctx[:out].string)
+      refute_match(/web UI at http/, ctx[:out].string)
+    end
+  end
+
+  def test_service_setup_prints_url
+    with_tmp_dir do |dir|
+      ctx = build(dir, service: true)
+      capture_io { ctx[:cmd].call }
+      assert_match(%r{http://127\.0\.0\.1:4567}, ctx[:out].string)
+    end
+  end
+
+  def test_shared_binary_path_passed_through
+    with_tmp_dir do |dir|
+      seen = []
+      installer = Object.new
+      installer.define_singleton_method(:install!) { |**| seen << :d; Hive::Commands::ServiceInstaller::Outcome.new(:unchanged) }
+      installer.define_singleton_method(:target_path) { "/d" }
+      installer.define_singleton_method(:messages) { [] }
+      web = Object.new
+      web.define_singleton_method(:install!) { |**| seen << :w; Hive::Commands::ServiceInstaller::Outcome.new(:unchanged) }
+      web.define_singleton_method(:target_path) { "/w" }
+      web.define_singleton_method(:messages) { [] }
+
+      report = healthy_diag
+      probe = Object.new
+      probe.define_singleton_method(:call) { report }
+      cmd = Hive::Commands::Setup.new(
+        project_path: dir,
+        service: true,
+        binary_path: "/exact/hive",
+        diagnostics: probe,
+        daemon_installer: installer,
+        web_installer: web,
+        init_runner: ->(*) { "ok" },
+        qmd_installer: -> { "ok" },
+        app_bundle: Object.new.tap { |o| o.define_singleton_method(:ensure_installed!) { "app" } },
+        output: StringIO.new,
+        err: StringIO.new
+      )
+      capture_io { cmd.call }
+      assert_equal %i[d w], seen
+      assert_equal "/exact/hive", cmd.instance_variable_get(:@binary_path)
+    end
+  end
+end
diff --git a/test/unit/commands/web/service_installer_test.rb b/test/unit/commands/web/service_installer_test.rb
new file mode 100644
index 00000000..c9782ae8
--- /dev/null
+++ b/test/unit/commands/web/service_installer_test.rb
@@ -0,0 +1,208 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/commands/web/service_installer"
+
+class WebServiceInstallerTest < Minitest::Test
+  include HiveTestHelper
+
+  def test_linux_template_contains_resolved_binary_and_web_subcommand
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux-gnu",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: true,
+        runner: ->(_argv) { true }
+      )
+      installer.install!(autostart: false)
+      unit = File.read(File.join(dir, ".config/systemd/user/hive-web.service"))
+      assert_includes unit, "ExecStart=#{hive} web"
+      assert_includes unit, "Restart=on-failure"
+      assert_includes unit, "StartLimitBurst=3"
+      refute_includes unit, "daemon start"
+    end
+  end
+
+  def test_macos_template_contains_resolved_binary_and_web_subcommand
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin23",
+        home: dir,
+        binary_path: "/opt/hive/bin/hive",
+        runner: ->(_argv) { true }
+      )
+      installer.install!(autostart: false)
+      plist = File.read(File.join(dir, "Library/LaunchAgents/local.hive-web.plist"))
+      assert_includes plist, "<string>/opt/hive/bin/hive</string>"
+      assert_includes plist, "<string>web</string>"
+      assert_includes plist, "SuccessfulExit"
+      assert_includes plist, "[ -x \"$0\" ] || exit 0"
+      # Exec argv must be `hive web`, not a daemon subcommand.
+      refute_match(%r{<string>daemon</string>}, plist)
+    end
+  end
+
+  def test_install_writes_once_and_noops_when_identical
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv; true }
+      )
+      first = installer.install!(autostart: true)
+      assert_equal :written, first.kind
+      second = installer.install!(autostart: true)
+      assert_equal :unchanged, second.kind
+    end
+  end
+
+  def test_install_refuses_drift_without_force_and_backs_up_with_force
+    with_tmp_dir do |dir|
+      path = File.join(dir, ".config/systemd/user/hive-web.service")
+      FileUtils.mkdir_p(File.dirname(path))
+      File.write(path, "custom unit\n")
+
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: true,
+        runner: ->(_argv) { true }
+      )
+      drifted = installer.install!(autostart: false)
+      assert_equal :drifted, drifted.kind
+      assert_equal "custom unit\n", File.read(path)
+
+      upgraded = installer.install!(autostart: false, force: true)
+      assert_equal :upgraded, upgraded.kind
+      assert upgraded.backup_path
+      assert File.exist?(upgraded.backup_path)
+      assert_includes File.read(path), "ExecStart="
+    end
+  end
+
+  def test_start_stop_status_select_correct_argv
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv; true }
+      )
+      installer.install!(autostart: false)
+      commands.clear
+
+      assert_equal :ok, installer.start!
+      assert_includes commands, %w[systemctl --user start hive-web]
+
+      commands.clear
+      assert_equal :ok, installer.stop!
+      assert_includes commands, %w[systemctl --user stop hive-web]
+
+      commands.clear
+      snap = installer.status_snapshot
+      assert_includes commands, %w[systemctl --user is-active hive-web]
+      assert snap["service_installed"]
+    end
+  end
+
+  def test_linux_restart_uses_service_manager
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: true,
+        runner: ->(argv) { commands << argv; true }
+      )
+
+      assert_equal :ok, installer.restart!
+      assert_equal [
+        %w[systemctl --user daemon-reload],
+        %w[systemctl --user restart hive-web]
+      ], commands
+    end
+  end
+
+  def test_macos_start_stop_use_launchctl
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin23",
+        home: dir,
+        binary_path: "/opt/hive/bin/hive",
+        runner: ->(argv) { commands << argv; true }
+      )
+      installer.install!(autostart: false)
+      commands.clear
+      path = installer.target_path
+
+      assert_equal :ok, installer.start!
+      assert_equal [ [ "launchctl", "load", path ] ], commands
+
+      commands.clear
+      assert_equal :ok, installer.stop!
+      assert_equal [ [ "launchctl", "unload", path ] ], commands
+    end
+  end
+
+  def test_macos_restart_unloads_then_loads_unit
+    with_tmp_dir do |dir|
+      commands = []
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "darwin23",
+        home: dir,
+        binary_path: "/opt/hive/bin/hive",
+        runner: ->(argv) { commands << argv; true }
+      )
+      installer.install!(autostart: false)
+      commands.clear
+      path = installer.target_path
+
+      assert_equal :ok, installer.restart!
+      assert_equal [ [ "launchctl", "unload", path ], [ "launchctl", "load", path ] ], commands
+    end
+  end
+
+  def test_linux_without_systemd_reports_autostart_unavailable
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: "/tmp/hive",
+        systemctl_available: false,
+        runner: ->(_argv) { true }
+      )
+      result = installer.install!(autostart: true)
+      assert_equal :autostart_unavailable, result.kind
+      assert File.exist?(installer.target_path)
+      assert_equal :autostart_unavailable, installer.start!
+    end
+  end
+
+  def test_unsupported_os_reports_clearly
+    with_tmp_dir do |dir|
+      installer = Hive::Commands::Web::ServiceInstaller.new(
+        host_os: "mingw32",
+        home: dir,
+        binary_path: "/tmp/hive",
+        runner: ->(_argv) { true }
+      )
+      result = installer.install!(autostart: true)
+      assert_equal :unsupported, result.kind
+      assert_equal :unsupported, installer.start!
+    end
+  end
+end
diff --git a/test/unit/commands/web_bind_policy_test.rb b/test/unit/commands/web_bind_policy_test.rb
new file mode 100644
index 00000000..7a822e40
--- /dev/null
+++ b/test/unit/commands/web_bind_policy_test.rb
@@ -0,0 +1,147 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/commands/web"
+require "hive/web/loopback"
+
+class WebBindPolicyTest < Minitest::Test
+  include HiveTestHelper
+
+  class ExecCaught < StandardError
+    attr_reader :env, :argv
+
+    def initialize(env, argv)
+      @env = env
+      @argv = argv
+      super("exec")
+    end
+  end
+
+  def test_loopback_classifier
+    %w[127.0.0.1 127.1.2.3 127.255.255.254 ::1 localhost 127.0.0.1:4567 [::1]].each do |addr|
+      assert Hive::Web::Loopback.address?(addr), "#{addr} should be loopback"
+    end
+    %w[0.0.0.0 192.168.1.1 10.0.0.1 8.8.8.8 example.com 126.0.0.1 128.0.0.1].each do |addr|
+      refute Hive::Web::Loopback.address?(addr), "#{addr} should not be loopback"
+    end
+  end
+
+  def test_loopback_bind_allowed_without_owner
+    with_tmp_global_config do
+      cfg = Hive::Config.load_global_web
+      cmd = Hive::Commands::Web.new
+      capture_io { cmd.apply_bind_policy!("127.0.0.1", cfg) }
+      capture_io { cmd.apply_bind_policy!("::1", cfg) }
+      capture_io { cmd.apply_bind_policy!("localhost", cfg) }
+    end
+  end
+
+  def test_non_loopback_without_owner_or_unsafe_refused
+    with_tmp_global_config do
+      cfg = Hive::Config.load_global_web
+      cmd = Hive::Commands::Web.new
+      error = assert_raises(Hive::Error) do
+        capture_io { cmd.apply_bind_policy!("0.0.0.0", cfg) }
+      end
+      assert_match(/refusing non-loopback bind/, error.message)
+      assert_match(/--unsafe/, error.message)
+    end
+  end
+
+  def test_non_loopback_with_owner_warns_and_allows
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), {
+        "web" => { "github" => { "owner" => "alice" } }
+      }.to_yaml)
+      cfg = Hive::Config.load_global_web
+      cmd = Hive::Commands::Web.new
+      _out, err = capture_io { cmd.apply_bind_policy!("0.0.0.0", cfg) }
+      assert_match(/WARNING binding 0.0.0.0/, err)
+      assert_match(/alice/, err)
+    end
+  end
+
+  def test_non_loopback_with_unsafe_warns_and_allows
+    with_tmp_global_config do
+      cfg = Hive::Config.load_global_web
+      cmd = Hive::Commands::Web.new(unsafe: true)
+      _out, err = capture_io { cmd.apply_bind_policy!("0.0.0.0", cfg) }
+      assert_match(/WARNING binding 0.0.0.0/, err)
+      assert_match(/--unsafe/, err)
+    end
+  end
+
+  def test_foreground_sets_loopback_mode_env_only_for_loopback_bind
+    with_tmp_global_config do
+      with_stub_rails_app(prepare_exit: 0) do
+        original = Kernel.method(:exec)
+        caught = nil
+        Kernel.define_singleton_method(:exec) do |env, *argv|
+          raise ExecCaught.new(env, argv)
+        end
+        begin
+          capture_io { Hive::Commands::Web.new(bind: "127.0.0.1").call }
+        rescue ExecCaught => e
+          caught = e
+        ensure
+          Kernel.define_singleton_method(:exec, original)
+        end
+        refute_nil caught
+        assert_equal "1", caught.env[Hive::Web::Loopback::ENV_MODE]
+      end
+    end
+  end
+
+  def test_docker_style_public_bind_does_not_set_loopback_mode
+    with_tmp_global_config do |home|
+      File.write(File.join(home, "config.yml"), {
+        "web" => { "github" => { "owner" => "hivebox-owner" } }
+      }.to_yaml)
+      with_stub_rails_app(prepare_exit: 0) do
+        original = Kernel.method(:exec)
+        caught = nil
+        Kernel.define_singleton_method(:exec) do |env, *argv|
+          raise ExecCaught.new(env, argv)
+        end
+        begin
+          capture_io { Hive::Commands::Web.new(bind: "0.0.0.0").call }
+        rescue ExecCaught => e
+          caught = e
+        ensure
+          Kernel.define_singleton_method(:exec, original)
+        end
+        refute_nil caught
+        refute caught.env.key?(Hive::Web::Loopback::ENV_MODE)
+      end
+    end
+  end
+
+  def test_non_loopback_refusal_happens_before_app_resolve
+    with_tmp_global_config do
+      cmd = Hive::Commands::Web.new(bind: "0.0.0.0")
+      resolved = false
+      cmd.define_singleton_method(:rails_app_dir) do
+        resolved = true
+        "/tmp/should-not-run"
+      end
+      assert_raises(Hive::Error) { capture_io { cmd.call } }
+      refute resolved, "bind policy must fail before rails_app_dir / db work"
+    end
+  end
+
+  # Minimal rails stub shared with web_command_test patterns.
+  def with_stub_rails_app(prepare_exit:)
+    Dir.mktmpdir("hive-webapp") do |dir|
+      FileUtils.mkdir_p(File.join(dir, "config"))
+      File.write(File.join(dir, "config", "application.rb"), "# rails app marker")
+      FileUtils.mkdir_p(File.join(dir, "bin"))
+      File.write(File.join(dir, "bin", "rails"), <<~SH)
+        #!/usr/bin/env bash
+        [ "$1" = "db:prepare" ] && exit #{prepare_exit}
+        exit 0
+      SH
+      FileUtils.chmod(0o755, File.join(dir, "bin", "rails"))
+      with_env("HIVEBOX_WEB_APP_DIR" => dir) { yield dir }
+    end
+  end
+end
diff --git a/test/unit/daemon/child_supervisor_test.rb b/test/unit/daemon/child_supervisor_test.rb
index 1c68f6d9..a92e4422 100644
--- a/test/unit/daemon/child_supervisor_test.rb
+++ b/test/unit/daemon/child_supervisor_test.rb
@@ -79,6 +79,37 @@ class HiveDaemonChildSupervisorTest < Minitest::Test
     end
   end
 
+  def test_maintenance_command_uses_current_binary_resolver_not_stale_daemon_binary
+    with_tmp_dir do |dir|
+      stale_marker = File.join(dir, "stale-ran")
+      current_marker = File.join(dir, "current-ran")
+      stale = File.join(dir, "stale", "hive")
+      current = File.join(dir, "current", "hive")
+      [ [ stale, stale_marker ], [ current, current_marker ] ].each do |path, marker|
+        FileUtils.mkdir_p(File.dirname(path))
+        File.write(path, "#!/bin/sh\ntouch #{Shellwords.escape(marker)}\n")
+        FileUtils.chmod(0o755, path)
+      end
+
+      sup = Hive::Daemon::ChildSupervisor.new(
+        hive_bin: stale,
+        maintenance_binary_resolver: -> { current },
+        log_dir_for_task: ->(project, slug) { File.join(dir, project, slug, "child.log") }
+      )
+      sup.spawn(
+        command_string: "hive daemon install --force",
+        project: Hive::Daemon::DispatchRequestQueue::GLOBAL_PROJECT,
+        slug: Hive::Daemon::DispatchRequestQueue::GLOBAL_SLUG,
+        stage: nil
+      )
+      completed = wait_for_completion(sup, max_attempts: 50)
+
+      assert_equal 1, completed.size
+      assert File.exist?(current_marker), "repair must execute through the current install binary"
+      refute File.exist?(stale_marker), "the daemon's stale HIVE_BIN must not repair itself"
+    end
+  end
+
   def test_spawn_tmpdir_log_fallback_loads_its_own_dependency
     script = <<~RUBY
       require "hive/daemon/child_supervisor"
diff --git a/test/unit/daemon/dispatch_request_queue_test.rb b/test/unit/daemon/dispatch_request_queue_test.rb
index a3c6f5e7..8b356109 100644
--- a/test/unit/daemon/dispatch_request_queue_test.rb
+++ b/test/unit/daemon/dispatch_request_queue_test.rb
@@ -327,6 +327,32 @@ class HiveDaemonDispatchRequestQueueTest < Minitest::Test
     refute Q.valid_argv?([ "hive", :run, "slug" ])
   end
 
+  def test_maintenance_argv_requires_exact_reserved_context
+    argv = Q::MAINTENANCE_ARGV
+
+    assert Q.valid_argv?(
+      argv,
+      project: Q::GLOBAL_PROJECT,
+      slug: Q::GLOBAL_SLUG
+    )
+    refute Q.valid_argv?(argv), "context-free validation must reject host maintenance"
+    refute Q.valid_argv?(argv, project: "real-project", slug: "real-task")
+    refute Q.valid_argv?(argv, project: Q::GLOBAL_PROJECT, slug: "real-task")
+  end
+
+  def test_write_request_rejects_maintenance_argv_for_real_project
+    Dir.mktmpdir("hive-dispatch-queue") do |dir|
+      assert_raises(ArgumentError) do
+        Q.write_request!(
+          project: "real-project",
+          slug: "real-task",
+          argv: Q::MAINTENANCE_ARGV,
+          state_home: dir
+        )
+      end
+    end
+  end
+
   def test_filename_for_is_chronologically_sortable
     a = Q.filename_for(created_at: Time.utc(2026, 5, 28, 18, 11, 44), request_id: "A")
     b = Q.filename_for(created_at: Time.utc(2026, 5, 28, 18, 13, 9), request_id: "B")
diff --git a/test/unit/daemon/dispatcher_test.rb b/test/unit/daemon/dispatcher_test.rb
index 50667c8b..d735bad4 100644
--- a/test/unit/daemon/dispatcher_test.rb
+++ b/test/unit/daemon/dispatcher_test.rb
@@ -3158,6 +3158,30 @@ end
     end
   end
 
+  def test_dispatch_request_rejects_maintenance_argv_for_real_project
+    Dir.mktmpdir("hive-dispatch-queue") do |state_home|
+      dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
+        rows: [], dispatch_request_state_home: state_home
+      )
+      write_request_file(
+        state_home,
+        slug: "s1",
+        request_id: "BADMAINT",
+        project: "p1",
+        argv: Q::MAINTENANCE_ARGV
+      )
+
+      dispatcher.tick(now: T0)
+
+      assert_empty sup.spawned
+      rejected = logger.events.find do |(name, attrs)|
+        name == :dispatch_request_rejected && attrs[:request_id] == "BADMAINT"
+      end
+      refute_nil rejected
+      assert_equal "invalid_argv", rejected[1][:reason]
+    end
+  end
+
   def test_dispatch_request_rejected_when_project_unknown
     Dir.mktmpdir("hive-dispatch-queue") do |state_home|
       dispatcher, sup, _ctrl, logger, _mw = make_dispatcher(
